IsoExt
Date: 2019-10-22

org.jmol.scriptext

## Class IsoExt

- java.lang.Object
- - org.jmol.scriptext.ScriptExt
  - - org.jmol.scriptext.IsoExt

-     public class IsoExt
      extends ScriptExt

- - ### Field Summary

    - ### Fields inherited from class org.jmol.scriptext.ScriptExt

      `chk, e, slen, st, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IsoExt()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addShapeProperty(javajs.util.Lst<java.lang.Object[]> propertyList, java.lang.String key, java.lang.Object value)`
    `private boolean` | `cgo()`
    `private boolean` | `contact()`
    `private java.lang.Object[]` | `createFunction(java.lang.String fname, java.lang.String xyz, java.lang.String ret)` for the ISOSURFACE command
    `private void` | `dipole()`
    `java.lang.String` | `dispatch(int iTok, boolean b, T[] st)`
    `private void` | `draw()`
    `private float[][]` | `floatArraySet(int i, int nX, int nY)`
    `private float[][][]` | `floatArraySetXYZ(int i, int nX, int nY, int nZ)`
    `private float[]` | `getAtomicPotentials(javajs.util.BS bsSelected, javajs.util.BS bsIgnore, java.lang.String fileName)`
    `private java.lang.Object` | `getCapSlabObject(int i, boolean isLcaoCartoon)`
    `private javajs.util.Lst<java.lang.Object>` | `getPlaneIntersection(int type, javajs.util.P4 plane, SymmetryInterface uc, float scale, int flags)`
    `private javajs.util.P3[]` | `getWithinDistanceVector(javajs.util.Lst<java.lang.Object[]> propertyList, float distance, javajs.util.P3 ptc, javajs.util.BS bs, boolean isShow)`
    `private java.lang.String` | `initIsosurface(int iShape)`
    `private void` | `isosurface(int iShape)`
    `private void` | `lcaoCartoon()`
    `private boolean` | `listIsosurface(int iShape)`
    `private void` | `mo(boolean isInitOnly, int iShape)`
    `private float[]` | `moCombo(javajs.util.Lst<java.lang.Object[]> propertyList)`
    `private int` | `moOffset(int index)`
    `private java.lang.String` | `setColorOptions(javajs.util.SB sb, int index, int iShape, int nAllowed)`
    `private void` | `setMoData(javajs.util.Lst<java.lang.Object[]> propertyList, int moNumber, float[] lc, int offset, boolean isNegOffset, int modelIndex, java.lang.String title, java.lang.String nboType, boolean isBeta)`
    `private void` | `setNBOType(java.util.Map<java.lang.String,java.lang.Object> moData, java.lang.String type)`

    - ### Methods inherited from class org.jmol.scriptext.ScriptExt

      `atomExpressionAt, centerParameter, checkLength, error, finalizeObject, floatParameter, getAllPoints, getColorTrans, getIntArray2, getPoint3f, getShapeProperty, getToken, init, intParameter, invArg, invPO, isFloatParameter, paramAsStr, setShapeId, setShapeProperty, showString, stringParameter, tokAt`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IsoExt

          public IsoExt()

  - ### Method Detail

    - #### dispatch

          public java.lang.String dispatch(int iTok,
                                           boolean b,
                                           T[] st)
                                    throws ScriptException

      Specified by:
        `dispatch` in class `ScriptExt`
      Throws:
        `ScriptException`

    - #### dipole

          private void dipole()
                       throws ScriptException

      Throws:
        `ScriptException`

    - #### draw

          private void draw()
                     throws ScriptException

      Throws:
        `ScriptException`

    - #### mo

          private void mo(boolean isInitOnly,
                          int iShape)
                   throws ScriptException

      Throws:
        `ScriptException`

    - #### setNBOType

          private void setNBOType(java.util.Map<java.lang.String,java.lang.Object> moData,
                                  java.lang.String type)
                           throws ScriptException

      Throws:
        `ScriptException`

    - #### moCombo

          private float[] moCombo(javajs.util.Lst<java.lang.Object[]> propertyList)

    - #### moOffset

          private int moOffset(int index)
                        throws ScriptException

      Throws:
        `ScriptException`

    - #### setMoData

          private void setMoData(javajs.util.Lst<java.lang.Object[]> propertyList,
                                 int moNumber,
                                 float[] lc,
                                 int offset,
                                 boolean isNegOffset,
                                 int modelIndex,
                                 java.lang.String title,
                                 java.lang.String nboType,
                                 boolean isBeta)
                          throws ScriptException

      Throws:
        `ScriptException`

    - #### isosurface

          private void isosurface(int iShape)
                           throws ScriptException

      Throws:
        `ScriptException`

    - #### lcaoCartoon

          private void lcaoCartoon()
                            throws ScriptException

      Throws:
        `ScriptException`

    - #### contact

          private boolean contact()
                           throws ScriptException

      Throws:
        `ScriptException`

    - #### cgo

          private boolean cgo()
                       throws ScriptException

      Throws:
        `ScriptException`

    - #### getAtomicPotentials

          private float[] getAtomicPotentials(javajs.util.BS bsSelected,
                                              javajs.util.BS bsIgnore,
                                              java.lang.String fileName)

      Parameters:
        `bsSelected` -
        `bsIgnore` -
        `fileName` -
      Returns:
        calculated atom potentials

    - #### getCapSlabObject

          private java.lang.Object getCapSlabObject(int i,
                                                    boolean isLcaoCartoon)
                                             throws ScriptException

      Throws:
        `ScriptException`

    - #### setColorOptions

          private java.lang.String setColorOptions(javajs.util.SB sb,
                                                   int index,
                                                   int iShape,
                                                   int nAllowed)
                                            throws ScriptException

      Throws:
        `ScriptException`

    - #### createFunction

          private java.lang.Object[] createFunction(java.lang.String fname,
                                                    java.lang.String xyz,
                                                    java.lang.String ret)

      for the ISOSURFACE command
      Parameters:
        `fname` -
        `xyz` -
        `ret` -
      Returns:
        [ ScriptFunction, Params ]

    - #### getWithinDistanceVector

          private javajs.util.P3[] getWithinDistanceVector(javajs.util.Lst<java.lang.Object[]> propertyList,
                                                           float distance,
                                                           javajs.util.P3 ptc,
                                                           javajs.util.BS bs,
                                                           boolean isShow)

    - #### addShapeProperty

          private void addShapeProperty(javajs.util.Lst<java.lang.Object[]> propertyList,
                                        java.lang.String key,
                                        java.lang.Object value)

    - #### floatArraySetXYZ

          private float[][][] floatArraySetXYZ(int i,
                                               int nX,
                                               int nY,
                                               int nZ)
                                        throws ScriptException

      Throws:
        `ScriptException`

    - #### floatArraySet

          private float[][] floatArraySet(int i,
                                          int nX,
                                          int nY)
                                   throws ScriptException

      Throws:
        `ScriptException`

    - #### initIsosurface

          private java.lang.String initIsosurface(int iShape)
                                           throws ScriptException

      Throws:
        `ScriptException`

    - #### listIsosurface

          private boolean listIsosurface(int iShape)
                                  throws ScriptException

      Throws:
        `ScriptException`

    - #### getPlaneIntersection

          private javajs.util.Lst<java.lang.Object> getPlaneIntersection(int type,
                                                                         javajs.util.P4 plane,
                                                                         SymmetryInterface uc,
                                                                         float scale,
                                                                         int flags)

      Parameters:
        `type` - unitcell or boundbox
        `plane` - plane to intersect, or null for just the full box
        `scale` -
        `uc` -
        `flags` - 1 -- edges only 2 -- triangles only 3 -- both
      Returns:
        Vector